"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = {
    /**
     *
     * @param commands
     * @param { Message } message
     * @returns {Promise<*>}
     */
    byPermission: (commands, message) => __awaiter(void 0, void 0, void 0, function* () {
        // Filter all commands based on the permissions specified and the user's permissions
        return commands.filter((command) => {
            let viable = false;
            if (command.permissions && command.permissions.length > 0) {
                command.permissions.forEach((permission) => {
                    // @ts-ignore
                    if (message.member && message.member.hasPermission(permission)) {
                        viable = true;
                    }
                });
            }
            else {
                viable = true;
            }
            return viable;
        });
    }),
};
